using System;
using System.Drawing;

namespace MouseWatcher
{
	public class Watcher
	{
		private Point watchPoint = new Point(100, 100);

		public Point watchLocation 
		{
			get { return watchPoint; }
			set { watchPoint = value; }
		}

		public void draw(Graphics g)
		{
			// Face
			Brush brush = new SolidBrush(Color.Blue);
			g.FillEllipse(brush, 0, 0, 100, 100);

			// Eyes
			brush = new SolidBrush(Color.Wheat);
			g.FillEllipse(brush, 20, 20, 20, 40);
			g.FillEllipse(brush, 60, 20, 20, 40);

			// Eyeballs
			brush = new SolidBrush(Color.Brown);
			int x, y;
			getEyeballLocation(20, 20, 20, 40, out x, out y);
			g.FillEllipse(brush, x, y, 10, 10);
			getEyeballLocation(60, 20, 20, 40, out x, out y);
			g.FillEllipse(brush, x, y, 10, 10);
		}

		private void getEyeballLocation(int topX, int topY, 
			int width, int height, 
			out int locationX, out int locationY)
		{
			int halfWidth = (int)((double)(width) / 2);
			int halfHeight = (int)((double)(height) / 2);
			int centerX = topX + halfWidth;
			int centerY = topY + halfHeight;

			int XOffset = watchPoint.X - centerX;
			if (XOffset > halfWidth/2) XOffset = halfWidth - 11;
			if (XOffset < -halfWidth) XOffset = -halfWidth + 1;

			int YOffset = watchPoint.Y - centerY;
			if (YOffset > halfHeight) YOffset = halfHeight - 11;
			if (YOffset < -halfHeight) YOffset = -halfHeight + 1;

			locationX = centerX + XOffset;
			locationY = centerY + YOffset;
		}			
	}
}

