/*
 * @author Venkat Subramaniam
 * DuraSoft, Inc.
 * http://www.durasoftcorp.com/download
 */

using System;

namespace IDisposable
{
	class User
	{
		[STAThread]
		static void Main(string[] args)
		{
			Console.WriteLine("We will create four objects. Are all of them cleaned up correctly?");

			Sample obj1 = new Sample("object 1");

			GC.Collect();
			GC.WaitForPendingFinalizers(); 
			// This is not a good idea. Defeats the performance gains by
			// lazy garbage collection thread. This is only for a demo. Do
			// not use in production code.

			Sample obj2 = new Sample("object 2");
			obj2.Dispose();

			Sample obj3 = new Sample("object 3");

			using (Sample obj4 = new Sample("object 4"))
			{
				obj4.ToString();
			}

			Console.WriteLine("End of main");
		}
	}
}
