/*
 * @author Venkat Subramaniam
 * DuraSoft, Inc.
 * http://www.durasoftcorp.com/download
 */

using System;

namespace WritingProperties
{
	public class Car
	{
		private readonly int year;
		private string bodyColor;

		public Car(int yearOfMake, string color)
		{
			year = yearOfMake;
			bodyColor = color;
		}

		public int YearOfMake
		{
			get { return year; }
			// No set method, YearOfMake property is read only
		}

		public virtual string Color
		{
			get { return bodyColor; }
			set 
			{
				if (value.CompareTo("Orange") == 0)
					throw new ApplicationException("Sorry, " +
						value + " is not a good color for a Car!");
				bodyColor = value;
			}
		}

		// Not a good example, but still an example of indexer
		public string this[string property]
		{
			get
			{
				if (property == "YearOfMake")
					return year.ToString();
				if (property == "Color")
					return bodyColor;
				throw new InvalidOperationException("Unknown property");
			}
		}
	}
}
